<?

require_once("include/general_func.inc.php");

dbconn();

loggedonly();

stdhead("Feedback");

$errcount = 0;

function field_err($message)
{
	global $errcount;
	$errcount++;
	if ($errcount == 1)
		echo ("<br><br><br><b>Errors</b>:<br><br>");
	echo (" - ".$message."<br><br>");
}

function insert_feedback($type, $feedback)
{
	global $CURUSER;
	/*
		CREATE TABLE `feedback` (
		`id` INT UNSIGNED NOT NULL ,
		`users_id` INT UNSIGNED NOT NULL ,
		`type` ENUM( 'bug', 'feature_request', 'abuse', 'other') NOT NULL ,
		`feedback_text` TEXT NOT NULL ,
		`is_done` TINYINT( 1 ) UNSIGNED NOT NULL ,
		`received` DATETIME NOT NULL ,
		PRIMARY KEY ( `id` ) ,
		INDEX ( `users_id` , `type` , `is_done` , `received` ) 
		) COMMENT = 'Feedback from users';
	*/
	
	safequery(
		"INSERT INTO feedback (users_id, type, feedback_text, is_done, received) VALUES (".
			$CURUSER["id"] .
			", '$type'" .
			", " . sqlesc($feedback) .
			", 0" .
			", NOW()".
		")");
	update_feedback_count();
	confirmation("Thank you for your feedback", "about.php", "Feedback received");
}

if (isset($_POST["type"]) && isset($_POST["feedback"]))
{
	global $errcount;
	$type = $_POST["type"];
	$feedback = $_POST["feedback"];
	if ($type != "bug_report" && $type != "feature_request" && $type != "abuse" && $type != "other")
		field_err("Choose type");
	if (strlen($feedback) > 2048)
		field_err("Too long feedback");
	if (strlen($feedback) < 5)
		field_err("Eh? Please be more descriptive :)");
	
	if ($errcount == 0)
		insert_feedback($type, $feedback);
}
else
{
	$type = "none";
	$feedback = "";
}

?>

<form method="post" action="feedback.php">
	<table class="table1" align=center cellpadding="0" cellspacing="0" width="100%">
		<tr>
			<td>
			<select class="input" name="type">
				<option value="none">Choose type</option>
				<option value="abuse">Report an abuse</option>
				<option value="bug_report">Bug report</option>
				<option value="feature_request">Feature request</option>
				<option value="other">Other</option>
			</select>
			</td>
		</tr>
		<tr>
			<td>
				Feedback:<br>
				<textarea class="input" name="feedback" rows="10" cols="80"><?php echo $feedback; ?></textarea><br>
				<br>
			</td>
		</tr>
		<tr>
			<td>
				<input type="submit" value="Submit feedback" class="input" />
			</td>
		</tr>
	</table>
</form>
<br>
<?
	stdfoot();
?>
