<?

require_once("include/bittorrent.inc.php");
require_once("include/general_func.inc.php");

if (!isset($_POST["whorecommended"]))
{
	die("Don't leave any of the fields blank");
}
if (!mkglobal("whorecommended:wantusername:wantpassword:passagain:email:emailagain"))
	die("!mkglobal");

function bark($msg) {
	genbark($msg, "Signup failed!");
}

$wantpassword = trim($wantpassword);
$passagain = trim($passagain);

if (empty($whorecommended) || empty($wantusername) || empty($wantpassword) || empty($email))
	bark("Don't leave any fields blank.");

if ($wantpassword != $passagain)
	bark("The passwords aren't the same. Try again.");

if (strtolower($email) != strtolower($emailagain))
	bark("The email addresses aren't the same. Try again.");

if (strlen($wantpassword) > 32)
	bark("Sorry, password is too long (max is 32 chars)");

if (strlen($wantpassword) < 6)
	bark("Your password password is only ".strlen($wantpassword)." chars long, tell me you're not serious! The password must be at least 6 chars long.");

if (!validemail($email))
	bark("That doesn't look like a valid email address.");

if (!preg_match('/^[a-z][\w.-]*$/is', $wantusername) || strlen($wantusername) > 15)
	bark("Invalid username. Must not be more than 15 characters long and no weird characters");

if (trim($whorecommended) == "" || strlen(trim($whorecommended)) < 3)
	bark("Fill the field \"From who did you hear of us\"");

$dictret = check_dict($whorecommended);
if ($dictret != null)
	bark($dictret);

dbconn();

$ret = safequery("SELECT COUNT(*) FROM user WHERE username='$wantusername'");
$row = mysql_fetch_array($ret);
$count = $row[0];
if ($count != 0)
{
	bark("The username you specified is unavailable.");
}

$requestip = $_SERVER["REMOTE_ADDR"];

$ret = safequery("SELECT COUNT(*) FROM user WHERE requestip='$requestip' AND status='notaccepted'");
$row = mysql_fetch_array($ret);
$count = $row[0];
if ($count != 0)
{
	bark("There is already a request waiting for acception from your IP address ($requestip). The request must be accepted/rejected before another account can be requested from your address. This is to prevent request spamming.");
}

$ret = safequery("SELECT COUNT(*) FROM user WHERE email='$email' AND status='notaccepted'");
$row = mysql_fetch_array($ret);
$count = $row[0];
if ($count != 0)
{
        bark("There is already a request waiting for acception from your email address. The request must be accepted before. This is to prevent request spamming.");
}

$secret = mksecret();

$id = mysql_insert_id();
$psecret = md5($secret);
$passhash = md5($wantpassword);
/*
$body = <<<EOD
You have requested a new user account on $tracker_url and you have
specified this address ($email) as user contact.

If you did not do this, please ignore this email. The person who entered your
email address had the IP address {$_SERVER["REMOTE_ADDR"]}. Please do not reply.

To confirm your user registration, you have to follow this link:

$tracker_url/confirm.php/$id/$psecret

After you do this, you will be able to use your new account. If you fail to
do this, you account will be deleted within a few days.
EOD;

*/

safequery("INSERT INTO `user` (username, passhash, secret, email, status, added, requestip, whorecommended) VALUES (" .
		sqlesc($wantusername).
		", '".$passhash."'".
		", ".sqlesc($secret).
		", ".sqlesc($email).
		", 'notaccepted'".
		", NOW()".
		", '$requestip'".
		", " . sqlesc($whorecommended) . ")");

$user_id = mysql_insert_id();
safequery("INSERT INTO user_ratio (user_id) VALUES (".$user_id.")");

update_user_small_stats_str("user_id = $user_id");

returnto("ok.php?type=request&email=" . urlencode($email));
?>
