<?
require_once('include/bittorrent.inc.php');
require_once('include/general_func.inc.php');

dbconn();

loggedinorreturn();

global $CURUSER;

//adds uploadrequest comment and returns the ID returned
function add_ur_comment($ur_id, $text)
{
	global $CURUSER;
	$user_id = $CURUSER["id"];
	safequery(
		"INSERT INTO uploadrequest_comment".
		" (uploadrequest_id, user_id, comment_date, comment_modified, comment_text)".
		" VALUES(".
		$ur_id.
		", " . $CURUSER["id"] .
		", NOW()" .
		", NULL" .
		", " . sqlesc($text) .
		")"
	);

	$insert_id = mysql_insert_id();

	update_comment_count($ur_id);

	return $insert_id;
}

function update_comment_count($ur_id)
{
	safequery(
		"UPDATE uploadrequest SET comments = ".
		"(SELECT COUNT(*) FROM uploadrequest_comment WHERE uploadrequest_id = $ur_id)".
		" WHERE id = $ur_id"
	);
}

function delete_ur_comment($comment_id)
{
	$ur_id = safequery_scalar("SELECT uploadrequest_id FROM uploadrequest_comment WHERE id = $comment_id");
	safequery("DELETE FROM uploadrequest_comment WHERE id = $comment_id");
	update_comment_count($ur_id);
	return $ur_id;
}

if (isset($_POST["id"]))
{
	$id = intval($_POST["id"]);
	if ($id < 1)
		usererr("Invalid ID '".$id."'");

	if (isset($_POST["addcomment"]))
	{
		$addcomment_text = trim($_POST["addcomment"]);
		if ($addcomment_text == "")
			usererr("Comment was left empty");

		$comment_id = add_ur_comment($id, $addcomment_text);
		confirmation("Comment was added with ID ".$comment_id, "viewuploadrequest.php?id=" . $id . "#" . $comment_id, "Comment added");
	}
	else
	{
		usererr("Missing addcomment parameter");
	}
}
else if (isset($_GET["deletecomment"]))
{
	$deletecomment = intval($_GET["deletecomment"]);
	if ($deletecomment < 1)
		usererr("Invalid value for deletecomment parameter");

	$owner = safequery_scalar("SELECT user_id FROM uploadrequest_comment WHERE id = $deletecomment");
	
	if (currentadmin() || $owner == $CURUSER["id"])
	{
		$ur_id = delete_ur_comment($deletecomment);
		confirmation("Comment ID ".$deletecomment . " was deleted", "viewuploadrequest.php?id=" . $ur_id, "Comment deleted");
	}
	else
	{
		usererr("Access denied");
	}
}
else if (isset($_POST["delete"]))
{
	$delete = intval($_POST["delete"]);
	if ($delete < 1)
		usererr("Invalid value for delete parameter");
	
	if (!isset($_POST["sure"]))
		usererr("You need to check the \"I'm sure\" checkbox");
	
	$owner = safequery_scalar("SELECT user_id FROM uploadrequest WHERE id = $delete");
	
	if (currentadmin() || $owner == $CURUSER["id"])
	{
		safequery("UPDATE uploadrequest SET deleted = 1 WHERE id = $delete");
		confirmation("Upload request ID " . $delete . " was deleted", "viewuploadrequests.php", "Upload request deleted");
	}
	else
	{
		usererr("Access denied");
	}
}

if (!isset($_GET["id"]) || intval($_GET["id"]) < 1)
{
	usererr(null, "Missing ID from URL");
}

$id = intval($_GET["id"]);

/*
 	 id 	int(10) 	 	UNSIGNED	Ei 	 	auto_increment 	 	 	 	 	 	 	
 	 name 	varchar(30)	latin1_swedish_ci	 	Ei 	 	 	 	 	 	 	 	 	
 	 description 	text	latin1_swedish_ci	 	Ei 	 	 	 	 	 	 	 	 	
 	 user_id 	int(10) 	 	UNSIGNED	Ei 	0 	 	 	 	 	 	 	 	
 	 matching_torrents 	int(10) 	 	UNSIGNED	Ei 	0 	 	 	 	 	 	 	 	
 	 status 	enum('bad', 'ok', 'good')	latin1_swedish_ci	 	Ei 	bad 	 	 	 	 	 	 	 	
 	 deleted 	tinyint(1) 	 	UNSIGNED	Ei 	0 	 	 	 	 	 	 	 	
 	 uploadrequest_date 	timestamp	 	 	Kyll. 	CURRENT_TIMESTAMP 	 
*/

//new way2: updating only count, using subqueries
function update_uploadrequest_matches($uploadrequest_id)
{
	$count = safequery_scalar(
		"SELECT	COUNT(*)".
		" FROM	torrent".
		" WHERE	id IN (".
		"	SELECT DISTINCT torrent_category.torrent_id ".
		"	FROM		torrent_category".
		"	WHERE		torrent_category.category_id IN (".
		"			SELECT category_id FROM uploadrequest_category WHERE uploadrequest_id = $uploadrequest_id".
		"			)".
		"	)".
		" AND	torrent.visible = 'yes'"
		);
	
	safequery("UPDATE uploadrequest SET matches_updated = NOW(), matching_torrents = " . $count . " WHERE id = ".$uploadrequest_id);
}

/*
//	new way: updating only count
function update_uploadrequest_matches($uploadrequest_id)
{
	$count = safequery_scalar(
		"SELECT		COUNT(*)".
		" FROM	uploadrequest_category".
		" CROSS JOIN	torrent_category".
		" WHERE		uploadrequest_category.uploadrequest_id = $uploadrequest_id".
		" AND		torrent_category.category_id = uploadrequest_category.category_id"
		//" GROUP BY	torrent_category.torrent_id"
		);
	
	safequery("UPDATE uploadrequest SET matches_updated = NOW(), matching_torrents = " . $count . " WHERE id = ".$uploadrequest_id);
}
*/

/*	old way
function update_uploadrequest_matches($uploadrequest_id)
{
	$res = safequery(
		"SELECT		torrent_category.torrent_id".
		" FROM		uploadrequest_category".
		" CROSS JOIN	torrent_category".
		" WHERE		uploadrequest_category.uploadrequest_id = $uploadrequest_id".
		" AND		torrent_category.category_id = uploadrequest_category.category_id".
		" GROUP BY	torrent_category.torrent_id".
		" LIMIT 100"
		);
	safequery("DELETE FROM uploadrequest_torrent WHERE uploadrequest_id = $uploadrequest_id");
	$count = 0;
	while ($row = mysql_fetch_array($res))
	{
		safequery("INSERT INTO uploadrequest_torrent (uploadrequest_id, torrent_id) VALUES (".$uploadrequest_id.", " . $row["torrent_id"] . ")");
		$count++;
	}
	safequery("UPDATE uploadrequest SET matches_updated = NOW(), matching_torrents = ".$count." WHERE id = ".$uploadrequest_id);
}
*/

global $uploadrequest_matches_update_interval;

function is_update_uploadrequest_matches_update_required($uploadrequest_id, $interval_minutes)
{
	$sql = 	"SELECT COUNT(*) FROM uploadrequest WHERE".
		" id = $uploadrequest_id AND (date_add(matches_updated, INTERVAL $interval_minutes MINUTE) <= NOW()".
		" OR matches_updated = '0000-00-00 00:00:00')";

	$res = safequery($sql);
	$row = mysql_fetch_array($res);
	return $row[0] == 1;
}

$need_to_update = is_update_uploadrequest_matches_update_required($id, $uploadrequest_matches_update_interval);
if ($need_to_update)
{
	update_uploadrequest_matches($id);
}

$res = safequery(
	"SELECT ".
	" uploadrequest.name, uploadrequest.description, uploadrequest.matching_torrents, uploadrequest.comments,".
	" uploadrequest.status, uploadrequest.deleted,".
	" uploadrequest.uploadrequest_date, uploadrequest.matches_updated, ".
	" user.id AS user_id, user.username".
	" FROM uploadrequest".
	" LEFT JOIN user".
	" ON user.id = uploadrequest.user_id".
	" WHERE uploadrequest.id = ".$id
	);

$row = mysql_fetch_array($res);
if (!$row)
	usererr(null, "Uploadrequest with ID $id was not found");

$name			= $row["name"];
$description		= $row["description"];
$matching_torrents	= $row["matching_torrents"];
$status			= $row["status"];
$deleted		= ($row["deleted"] == 1);
$uploadrequest_date	= $row["uploadrequest_date"];
$user_id		= $row["user_id"];
$username		= $row["username"];
$matches_updated	= $row["matches_updated"];
$comments		= $row["comments"];

/*
function get_categories_by_uploadrequest(
        $uploadrequest_id,
        $fields = "category.id, category.name, category.fullname, category.is_abstract",
        $orderby = "")
*/

$categories = get_categories_by_uploadrequest($id);

stdhead("Upload request: $name");

if ((currentadmin() || $user_id == $CURUSER["id"]) && (!$deleted))
{
?>
<center>
<form action="viewuploadrequest.php" method="post">
<input class="input" name="delete" type="hidden" value="<?=$id?>" />
<input class="input" type="submit" value="Delete this upload request" />
<input type="checkbox" name="sure" value="" >Yeah, I'm absolutely sure</input>
</form>
</center>
<?
}

if ($deleted)
	echo "<b><font color=\"#ff0000\">THIS UPLOAD REQUEST HAS BEEN DELETED</font></b><br><br>";

function show_search_url($categories)
{
	echo "./?";
	$search_index = 0;
	while ($cat = mysql_fetch_array($categories))
	{
		$search_index++;
		if ($search_index > 1)
			echo "&";
		echo "category" . $search_index . "=" . $cat["id"];
	}
}

?>
<center>

<table width="50%">
<?
	echo "<tr><td>Name</td><td>" . htmlspecialchars($name) . "</td></tr>\r\n";
	echo	"<tr><td>Currently matching torrents<br>" .
		"<font size=\"1\">(updated every " . $uploadrequest_matches_update_interval ." minutes)</font></td>\r\n";
	echo "<td>" . $matching_torrents;
	echo "<br>[<a href=\"";
	show_search_url($categories);
	mysql_data_seek($categories, 0) or die ("cannot seek");
	echo "\">view matching torrents</a>]\r\n";
	echo "</td></tr>\r\n";
	
	if (currentadmin())
	{
		echo "<tr><td>Torrent matches updated at</td><td>" . $matches_updated;
		if ($need_to_update)
			echo "<br>(was updated when you opened this page)";
		echo "</td></tr>\r\n";
	}
	
	echo "<tr><td>Status (user specified)</td><td>";
	show_uploadrequest_status($status);
	echo "</td></tr>\r\n";
	echo "<tr><td>Date modified</td><td>".$uploadrequest_date."</td></tr>\r\n";
	echo "<tr><td>User</td><td>".userlink($user_id, $username)."</td></tr>\r\n";
	echo "<tr><td>Categories</td><td>\r\n";
	show_categories($categories);
	echo "</td></tr>\r\n";
	echo "<tr><td>Number of comments</td><td>".$comments."</td></tr>\r\n";
	echo "<tr><td>Description</td></tr>\r\n";
	echo "<tr><td><br>".parse_comment($description)."</td></tr>\r\n";
?>
</table>
</center>
<?

/*
function get_torrents_basic(
        $terms,
        $limit = 0,
        $offset = 0,
        $orderby = "torrent.added DESC",
        $fields = null,
        $joincat = true,
        $countonly = false
        )
*/

function get_ur_comments($ur_id)
{
	return safequery(
		"SELECT		uploadrequest_comment.id\n".
		",		uploadrequest_comment.comment_date\n".
		",		uploadrequest_comment.uploadrequest_id\n".
		",		uploadrequest_comment.comment_text\n".
		",		user.id AS user_id\n".
		",		user.username\n".
		"FROM		uploadrequest_comment\n".
		"LEFT JOIN	user\n".
		"ON		user.id = uploadrequest_comment.user_id\n".
		"WHERE		uploadrequest_comment.uploadrequest_id = $ur_id\n".
		"ORDER BY	uploadrequest_comment.comment_date\n"
		);
}

function show_ur_comment($row, $is_requester, $allow_delete)
{
	/*
	echo "<tr>".
		"<td>" . $row["comment_date"] . " - " .	userlink($row["user_id"], $row["username"]);
	*/
	echo "<a name=\"" . $row["id"] . "\">\n";
	echo "<tr>".
		"<td><br>" . userlink($row["user_id"], $row["username"]);
	
	if ($is_requester)
	{
		echo " <b>(requester)</b>";
	}
	echo " - " . $row["comment_date"];
	
	if ($allow_delete)
	{
		echo " [<a href=\"viewuploadrequest.php?deletecomment=".$row["id"] . "\">delete</a>]";
	}
	echo ":<br>" . parse_comment($row["comment_text"]);
	echo "</td>";
	echo "</tr>";
}

function show_ur_comments($res, $requester_id)
{
	echo "<table border=\"0\">";
	$allow_modify = false;
	$is_requester = false;
	while ($row = mysql_fetch_array($res))
	{
		$is_requester = ($row["user_id"] == $requester_id);
		$allow_modify = $is_requester || currentadmin();

		show_ur_comment($row, $is_requester, $allow_modify);

	}
	echo "</table>";
}

echo "<br><br>";

if ($comments > 0)
{
	$res = get_ur_comments($id);
	show_ur_comments($res, $user_id);
}

?>
<br>
<form action="" method="post">
<input class="input" name="id" type="hidden" value="<?=$id?>" />
Add a comment: (<a href="bbcode.php">BBCode allowed</a>)<br>
<textarea class="input" name="addcomment" rows="10" cols="80"></textarea><br>
<br>
<input class="input" type="submit" value="Add comment" />
</form>
<?

stdfoot();

?>
